/*
 * surprises/double-surprises.c --
 *
 * Surprises with doubles (not only in C).
 */

#include <stdio.h>
#include <math.h>

int main(void)
{
    double x, y; int c;
    
    x = 2.0/0.0;
    printf("%e\n", x);                  /* inf */

    x = INFINITY + 1;
    printf("%e\n", x);                  /* inf */

    x = INFINITY - INFINITY;
    printf("%e\n", x);                  /* nan */
    
    x = (1 + 1e20) - 1e20;
    y = 1 + (1e20 - 1e20);
    printf("%g == %g\n", x, y);         /* 0 == 1 */

    for (x = 0.0, c= 0; x < 1.0; x += 0.1) c++;
    printf("%d == 10\n", c);            /* 11 == 10 */
    
    x = 10.0/9.0;
    printf("%.50g\n", x);       /* 1.1111111111111111604543566500069573521614074707031 */
    return 0;
}
